<template>
    <!-- Validate -->
    <div class="validate-screen">
        <div class="dialog-wrapper validate-esn">
            <div class="dialog">
                <div class="info-text-block text-center">
                    <h2>Validate Device</h2>
                    <p class="bodyl-text">Please enter your ESN or IMEI below to check your device for compatibility with.</p>
                </div>
            </div>
        </div>
        <div class="dialog-wrapper validate-esn">
            <form @submit.prevent="checkDevice()" class="text-center">
                <div class="form-group">
                    <div class="pwd-custom-input-wrapper light-input"
                         :class="{'has-error': hasError , 'silver-wrapper': this.$root.rootUserNetwork === '123'}"
                    >
                        <label for="validateEsn">ESN or IMEI</label>
                        <div class="pwd-custom-input">
                            <input required
                                   type="tel"
                                   id="validateEsn"
                                   v-model="esn"
                                   @input="disableErrorStatus"
                                   :disabled="loadStatus">
                            <button class="help-tooltip" type="button" v-tooltip="{content:'You can look your ESN or IMEI by dialing *#06# on your device.', classes:'info'}">
                                <img src="../../../../../images/Info.svg" alt="info">
                            </button>
                            <div v-if="hasError" class="help-block">{{ checkDeviceError }}</div>
                            <div v-if="this.$root.rootUserNetwork === '123'" class="is-device">
                                <label>
                                    <input type="checkbox" v-model="is4g">
                                    4G Device?
                                    <span class="checkbox-custom"></span>
                                </label>
                            </div>
                        </div>
                    </div>
                    <!--  <p class="text-left custom-text">ESN - Electronic Serial Number is a unique 32-bits identification number embedded by manufacturers in wireless phones, typically found on a label under the cellular phone's battery.</p> -->
                </div>
                <div class="form-group esn-button">
                    <button class="btn btn-main active" :class="{ 'load': loadStatus }" type="submit">
                        {{ loadStatus ? 'Loading' : 'Check My Device' }}
                    </button>
                </div>
            </form>
        </div>
    </div>
</template>

<script>
    import Client from '../../../../modules/http-custom';

    export default {
        data() {
            return {
                esn: '',
                hasError: false,
                checkDeviceError: '',
                loadStatus: false,
            }
        },
        watch: {
            hasError: function () {
                this.$root.eventHub.$emit('errorStateChanged', this.hasError);
            },
            loadStatus: function () {
                this.$root.eventHub.$emit('loadStatusChanged', this.loadStatus);
            },
        },
        methods: {
            disableErrorStatus() {
                this.hasError = false;
            },

            checkDevice() {
                this.loadStatus = true;
                this.hasError = false;
                Client.call(`network/${this.$root.rootUserNetwork}/device/check`, {}, 'post', {
                    esn: this.esn,
                })
                    .then(response => {
                        this.loadStatus = false;
                        if (response.data.status) {
                            this.$root.eventHub.$emit('esnChanged', this.esn);
                            this.goToNext();
                        } else {
                            this.hasError = true;
                            this.checkDeviceError = response.data.error.message || 'Invalid ESN entered';
                        }
                    })
                    .catch(error => {
                        this.loadStatus = false;
                        this.hasError = true;
                        this.checkDeviceError = error.response.data.message;
                        if (error.response.status !== 500) {
                            this.errorHandler(error);
                        }
                    });
            },
        },
        props: {
            is4g: {
                type: Boolean,
                required: false,
                default: true,
            },
        },
        inject: ['goToNext']
    }
</script>
